fn main() {
    let v1 = vec![1, 2, 3];
    let v1_iter = v1.iter(); // iterator are lazy

    for val in v1_iter {
        println!("Got: {val}");
    }

    // methods that produce other iterators
    // iterator adaptors are methods defined on Iterator trait
    // that don't consume the iterater; instead, they produce
    // different iterators by changing some aspect of the
    // original iterator.
    let v1: Vec<i32> = vec![1, 2, 3];
    v1.iter().map(|x| x + 1);

    // stopped here:
    // https://rust-book.cs.brown.edu/ch13-02-iterators.html#methods-that-produce-other-iterators
}

// the iterator trait and the next method
// in the std library
pub trait Iterator {
    // This is an associated type with this trait
    // Will learn more about these in chapter 20
    type Item;

    fn next(&mut self) -> Option<Self::Item>;
}
